Index: trunk/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+Level                         : 4.1
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+Level                         : 4
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+Level                         : 5
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+Level                         : 5
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+Level                         : 5
 
 #======== File I/O ===============
Index: trunk/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg
===================================================================
--- trunk/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg	(revision 540)
+++ trunk/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg	(revision 595)
@@ -1,4 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+Level                         : 5
 
 #======== File I/O ===============